'BIG TIME IN 4 ROWS

$regfile = "m328pdef.dat"                                   ' ATmega328P
$crystal = 16000000                                         ' 16MHz
$swstack = 50
$hwstack = 40                                               ' po potrebi povecati na 60 (vidi pripadajuci clanak za "Big time") 
$framesize = 64

'Mladen Cempuh , 12.2024.

'------------------------------------------------------------
'DEFINIRANJE LCD DISPLEJA U 4 BITNOM RADU

Config Lcd = 20 * 4                                         ' izbor LCD2004

Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portb.5 , Db7 = Portb.4 , Rs = Portc.5 , E = Portc.4
Cls
Cursor Off

Backlight Alias Portb.3                                     ' opcija upravljanja rasvjetom LCD-a
Config Backlight = Output
Backlight = 1                                               ' Backlight = 1 --> rasvjeta LCD-a ukljucena

'------------------------------------------------------------
'DEFINIRANJE ULAZA ZA TIPKE:

Up$ Alias Pind.0                                            ' ulaz za tipku UP za RTC
Config Up$ = Input
Portd.0 = 1

Down$ Alias Pind.1                                          ' opcija ulaza za tipku DOWN za RTC, samo ako je konstanta Down_key = 1
Config Down$ = Input
Portd.1 = 1

Enter$ Alias Pind.2                                         ' ulaz za tipku Enter za RTC
Config Enter$ = Input
Portd.2 = 1

Const Down_key = 1                                          ' konstanta Down_key = 1 --> koristi se tipka DOWN ,a ako je 0 ne koristi se

'------------------------------------------------------------
'DEFINIRANJE I2C LINIJA ZA KOMUNIKACIJU SA DS3231:

 Config Scl = Portd.7                                       ' izlaz SCL

 Config Sda = Portd.6                                       ' izlaz SDA

 I2cinit                                                    ' inicijaliziraj I2C komunikaciju

'-------------------------------------------------------------
$include "DS3231$SE.sub"                                    ' knjizica za rad DS3231 RTC-a
'-------------------------------------------------------------
$include "DS3231$set.inc"                                   ' knjizica za namjestanje datuma i vremena DS3231 RTC-a
'-------------------------------------------------------------
$include "big_time_4_rows.inc"                              ' knjizica za veliki cetveroredni format ispisa sati i minuta iz RTC-a
'-------------------------------------------------------------

 Ds3231$set                                                 ' naredba za namjestanje datuma i vremena DS3231 RTC-a

Do

 Ds3231$read                                                ' ucitavanje sec, min, hour, day, date, month, year

 Big_time 1 , 1                                             ' prikaz sati i minuta u velikom formatu

 Locate 1 , 18 : Lcd_dan_slo                                ' prikaz dana u tjednu na slovenskom jeziku
' Locate 1 , 18 : Lcd_dan_hr                                 ' prikaz dana u tjednu na hrvatskom jeziku
' Locate 1 , 18 : Lcd_day                                    ' prikaz dana u tjednu na engleskom jeziku

 Locate 4 , 19 : Lcd Bcd(ds3231$sec)                        ' prikaz sekundi

' Mjesto za pisanje ostalog dijela korisnickog programa

' Ako se prikazuju na LCD-u sekunde tada se Do-Loop mora izvrsavati u vremenu do 0,2 sekunde

' Ako se Do-Loop izvrsava duze tada ne prikazivati na LCD-u sekunde

  Waitms 100                                                ' opcijska pauza, moze bez nje

Loop


End