'              DS3231 RTC DATE AND TIME SETTING

'Version 2.

'DS3231$SE.sub is used

'Mladen Cempuh 11.2024. ; cempuh.mladen@gmail.com
'--------------------------------------------------------

 Ds3231$write_control &B00000000                            ' SQW=1Hz, Disable INT, Disable Alarm1,Alarm2, Disable Temperature

'--------------------------------------------------------

Config Submode = New

'================= Command: Ds3231$set ===================

Sub Ds3231$set()

Local Count_5s As Byte

  Count_5s = 4

Local Input_data As Byte , Pos_x As Byte

Local Data_max As Byte , Data_min As Byte

Local _days As Byte , 255$_to As Byte

Local _year As Byte , _month As Byte , _date As Byte , _day_of_week As Byte , _hour As Byte , _min As Byte , _sec As Byte

   If Enter$ = 0 Then

    Cls

    Lcd "ENTER 5s FOR RTC"

    Wait 1

   End If

Enter$_5s:

  If Enter$ = 1 Then Goto End_ds3231$set                    ' ako nakon reseta nije pritisnuta tipka ENTER zavrsi naredbu

  Wait 1                                                    '  Enter$ = 0 (pritisnuta tipka ENTER), cekaj 1 sekundu

  Decr Count_5s                                             ' dekrementiraj brojac Count_5s za  vrijeme 5 sekundi

  If Count_5s > 0 Then Goto Enter$_5s                       ' ako je brojac veci od 0, nije proslo 5 sekundi,idi na ponovno testiranje tipke ENTER

' Upis parametara za RTC:                                     ' proslo je 5 sekundi, idi na upis parametara za RTC

Cls

 Lcd " Set RTC"

 Waitms 500

 Gosub Wait_enter_free

 Ds3231$yr = 36 : Ds3231$mth = 1 : Ds3231$dte = 1

 Ds3231$hour = 0 : Ds3231$min = 0 : Ds3231$sec = 0

 Cls

 Lcd "DAY  DD.MM.YEAR"


' Upis godine:

 Data_max = 99 : Data_min = 24 : Input_data = Data_min

Lab$_year:

 Gosub Up_down$

 _year = Input_data

 Ds3231$yr = Makebcd(_year)

 Locate 2 , 12 : Lcd "20" ; Bcd(ds3231$yr) ; "."

 If Enter$ = 1 Then Goto Lab$_year

 Gosub Wait_enter_free

' Upis mjeseca:

 Data_max = 12 : Data_min = 1 : Input_data = Data_min

Lab$_month:

 Gosub Up_down$

 _month = Input_data

 Ds3231$mth = Makebcd(_month)

 Locate 2 , 9 : Lcd Bcd(ds3231$mth) ; "."

 If Enter$ = 1 Then Goto Lab$_month

 Gosub Wait_enter_free

' Upis datuma:

 Gosub Days$_in_month

 Data_max = _days : Data_min = 1 : Input_data = Data_min

Lab$_date:

 Gosub Up_down$

 Ds3231$dte = Makebcd(input_data)

 Locate 2 , 6 : Lcd Bcd(ds3231$dte) ; "."

 If Enter$ = 1 Then Goto Lab$_date

 Gosub Wait_enter_free

' Upis dana u tjednu:

 Data_max = 7 : Data_min = 1 : Input_data = Data_min

Day$_in_week:

 Gosub Up_down$

 Ds3231$day = Makebcd(input_data)

 Locate 2 , 1 : Lcd_day

 If Enter$ = 1 Then Goto Day$_in_week

 Gosub Wait_enter_free

 Ds3231$write_date                                          ' upis day, date, month i year u chip DS3231

Cls

 Locate 1 , 5 : Lcd "HH:MM:SS"

' Upis sati:

 Data_max = 23 : Data_min = 0 : Input_data = Data_min : 255$_to = 23

Lab$_hour:

 Gosub Up_down$

 Ds3231$hour = Makebcd(input_data)

 Locate 2 , 5 : Lcd Bcd(ds3231$hour) ; ":"

 If Enter$ = 1 Then Goto Lab$_hour

 Gosub Wait_enter_free

' Upis minuta:

 Data_max = 59 : Data_min = 0 : Input_data = Data_min : 255$_to = 59

Lab$_min:

 Gosub Up_down$

 Ds3231$min = Makebcd(input_data)

 Locate 2 , 8 : Lcd Bcd(ds3231$min) ; ":"

 If Enter$ = 1 Then Goto Lab$_min

 Gosub Wait_enter_free

' Upis sekunda:

 Data_max = 59 : Data_min = 0 : Input_data = Data_min : 255$_to = 59

Lab$_sec:

 Gosub Up_down$

 Ds3231$sec = Makebcd(input_data)

 Locate 2 , 11 : Lcd Bcd(ds3231$sec)

 If Enter$ = 1 Then Goto Lab$_sec

 Ds3231$write_time                                          ' upis sec, min i hour u chip DS3231

 Gosub Wait_enter_free

 Goto End_ds3231$set

'------------------------------------------------------------
Wait_enter_free:

Enter$_0:

  If Enter$ = 0 Then Goto Enter$_0                          'cekaj u petlji dok Enter$ ne postane 1 (otpustena tipka ENTER)

  Return
'------------------------------------------------------------

Up_down$:

 Debounce Up$ , 0 , Data_incr$ , Sub                        ' idi na potprogram Data_incr$ na silazni brid od Up$

#if Down_key = 1                                            ' uvjetno kompajliranje ako je Down_key = 1

  Debounce Down$ , 0 , Data_decr$ , Sub                     ' idi na potprogram Data_decr$ na silazni brid od Down$

#endif

 Return

Data_incr$:

   Incr Input_data                                          ' inkrementiraj Input_data

   If Input_data > Data_max Then Input_data = Data_min

   Return                                                   ' vrati se iz potprograma Data_incr$

#if Down_key = 1                                            ' uvjetno kompajliranje ako je Down_key = 1

Data_decr$:

  Decr Input_data                                           'dekrementiraj Input_data

  If Input_data = 255 Then Input_data = 255$_to

  If Input_data < Data_min Then Input_data = Data_max

  Return                                                    'vrati se iz potprograma Data_decr$

#endif

'-------------------------------------------------------------

Days$_in_month:

 _days = Lookup(_month , Days$_data )

Days$_data:

Data 0 , 31 , 28 , 31 , 30 , 31 , 30 , 31 , 31 , 30 , 31 , 30 , 31

 If _month = 2 Then

  _days = _year And &H03

    If _days = 0 Then

       _days = 29

    Else

       _days = 28

    End If

 End If

Return

End_ds3231$set:

Cls

End Sub